"""
------------------------------------------------------------------------------
           Name: TEST_GPRS.py
         Author: Daniele De Santis (desantis@areasx.com)
        Version: 1.0
  Last Modified: 05/02/07
    Description: Test connessione GPRS
                 
          Note : 
------------------------------------------------------------------------------
"""
# importo i built-in modules
import MDM
import MOD
import sys
import GPIO


APN           = "web.omnitel.it"
#APN           = "ibox.tim.it"
SRV_ADDR      = "195.130.xxx.xxx"
SRV_PORT      = 80
WEB_PATH      = "sxpy.php"


TIMEOUT_CXT     = 20
TIMEOUT_MINIMUM = 5
TIMEOUT_CONNECT = 100
TIMEOUT_DWNLD = 150

XML_END = '</SXPY>'
XML_START = '<SXPY>'

r=GPIO.setIOdir(1,0,0) #port 1  input
r=GPIO.setIOdir(8,0,0) #port 8  input
r=GPIO.setIOdir(2,0,1) #port 2  output
r=GPIO.setIOdir(6,0,1) #port 6  output
r=GPIO.setIOdir(7,0,1) #port 7  output


#Funzioni

################## FUNCTION DEFINITION ####################
#returns data downloaded in a duration of time equal to TIMEOUT_DWNLD
def GetData():
  data = ' '
  timer = MOD.secCounter()
  timeout = MOD.secCounter() + TIMEOUT_DWNLD
  datatmp = MDM.receive(50)
  while ((datatmp.find(XML_END) == -1) and (datatmp.find(XML_END) == -1) and (timer > 0) ):
    data = data + datatmp
    datatmp = MDM.receive(50)
    timer = timeout - MOD.secCounter()
  if ((datatmp.find(XML_END) != -1) or (datatmp.find(XML_END) != -1)):
    data = data + datatmp
  else:
    data = ' '
  return data

print "Test GPRS"
#Check registrazione
while(1):
  res = MDM.send('AT+CGREG?\r',0)
  res = MDM.receive(4*TIMEOUT_MINIMUM)
  if (res.find ('+CGREG: 0,1') != -1):
    print "Modem registrato!"
    break
  MOD.sleep(50)



while(1):
  
  if(GPIO.getIOvalue(8)==0 or GPIO.getIOvalue(1)==1):
    GET = "GET /%s?IN1=%d&IN2=%d HTTP/1.0\r\n\r\n" % (WEB_PATH, GPIO.getIOvalue(1),not(GPIO.getIOvalue(8)))
    s=GPIO.setIOvalue(2,1) #LED TEST ON
    print 'START TX GPRS'
    res = MDM.send('AT+CGDCONT=1,"IP","',0)
    res = MDM.send(APN,0)
    res = MDM.send('"\r',0)
    res = MDM.receive(TIMEOUT_CXT)
    res = res.find ('OK')
    if (res == -1):
      print 'ERROR set PDP context'
    else:
      tmp="AT#SKTSET=0,%d,\"%s\"\r" % (SRV_PORT,SRV_ADDR)
      res = MDM.send(tmp,0)
      res = MDM.receive(4*TIMEOUT_MINIMUM)
    #avvia la connessione con l'host
      res = MDM.send('AT#SKTOP\r',0)
      timer = MOD.secCounter()
      timeout = MOD.secCounter() + TIMEOUT_CONNECT
      res = MDM.receive(TIMEOUT_MINIMUM)
      res = res.find('CONNECT')
    ############# wait for connect ############
      while ((res == -1)and (timer > 0) ):
        res = MDM.receive(TIMEOUT_MINIMUM)
        res = res.find('CONNECT')
        timer = timeout - MOD.secCounter()
      if (res != -1):
        print 'Connesso'
    ############# send the command of getting data
        res = MDM.send(GET,0)
        data = ' '
    ############ get data
        print 'RX DATA'
        data = GetData()
        if (data!=' '):
          print 'DOWNLOAD END'
          if(data.find('<R1>1</R1>')!= -1):
            s=GPIO.setIOvalue(6,1)
          else:
            s=GPIO.setIOvalue(6,0)
          
          if(data.find('<R2>1</R2>')!= -1):
            s=GPIO.setIOvalue(7,1)
          else:
            s=GPIO.setIOvalue(7,0)
          print data
        else:
          print 'ERROR RX DATA'
      else:
        print 'NON CONNESSO!'
    ############# return to OnLineCommandMode
      res = MDM.send('+++\r',0)
      print 'END'
      MOD.sleep(50)
      s=GPIO.setIOvalue(2,0) #LED TEST OFF
sys.exit(0)
